# std::reverse_copy

From cppreference.com
< cpp‎ | algorithm

Defined in header `<algorithm>` |  |
template< class BidirIt, class OutputIt > OutputIt reverse_copy( BidirIt first, BidirIt last, OutputIt d_first ); | (1) |
template< class ExecutionPolicy, class BidirIt, class ForwardIt > ForwardIt reverse_copy( ExecutionPolicy&& policy, BidirIt first, BidirIt last, ForwardIt d_first ); | (2) | (since C++17)

1) Copies the elements from the range `[first, last)` to another range beginning at `d_first` in such a way that the elements in the new range are in reverse order.
Behaves as if by executing the assignment *(d_first + (last - first) - 1 - i) = *(first + i) once for each non-negative `i < (last - first)`
If the source and destination ranges (that is, `[first, last)` and `[d_first, d_first+(last-first))` respectively) overlap, the behavior is undefined.
2) Same as (1), but executed according to `policy`. This overload does not participate in overload resolution unless std::is_execution_policy_v<std::decay_t<ExecutionPolicy>> is true

### Parameters

first, last | - | the range of elements to copy
d_first | - | the beginning of the destination range
Type requirements
- `BidirIt` must meet the requirements of `BidirectionalIterator`.
- `OutputIt` must meet the requirements of `OutputIterator`.
- `ForwardIt` must meet the requirements of `ForwardIterator`.

### Return value

Output iterator to the element past the last element copied.

### Exceptions

The overload with a template parameter named `ExecutionPolicy` reports errors as follows:

- If execution of a function invoked as part of the algorithm throws an exception and `ExecutionPolicy` is one of the three standard policies, std::terminate is called. For any other `ExecutionPolicy`, the behavior is implementation-defined.
- If the algorithm fails to allocate memory, std::bad_alloc is thrown.

### Possible implementation

    template<class BidirIt, class OutputIt>
    OutputIt reverse_copy(BidirIt first, BidirIt last, OutputIt d_first)
    {
        while (first != last) {
            *(d_first++) = *(--last);
        }
        return d_first;
    }

### Example

Run this code

    #include <vector>
    #include <iostream>
    #include <algorithm>

    int main()
    {
        std::vector<int> v({1,2,3});
        for (const auto& value : v) {
            std::cout << value << " ";
        }
        std::cout << '\n';

        std::vector<int> destination(3);
        std::reverse_copy(std::begin(v), std::end(v), std::begin(destination));
        for (const auto& value : destination) {
            std::cout << value << " ";
        }
        std::cout << '\n';
    }

Output:

    1 2 3
    3 2 1

### Complexity

Linear in the distance between `first` and `last`

### See also

reverse | reverses the order of elements in a range (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/algorithm/reverse_copy&oldid=90643"